;================================================================
;modifies draw distance in real-time and sets values
;================================================================
ModifyDrawDistanceRT:	;esp+4 = DWORD float to add to draw dist
push eax
push ecx
push edx
push ebx
push edi

	invoke GetTickCount
	mov [DrawDistDisplayTime],eax
	mov ebx,[DrawDistanceVarADDR]

invoke GetCurrentProcessId
invoke OpenProcess,PROCESS_VM_WRITE+PROCESS_VM_OPERATION,0,eax
	       test eax,eax
		    jz CannotModDrawDist_RT
	       mov edi,eax

;unprotect ".rdata" section
	mov ecx,[DATASEC_STARTADDR]
	mov edx,[RDATA_START_ADDR]
	sub ecx,edx
invoke VirtualProtectEx,edi,edx,ecx,PAGE_READWRITE,VOldProtectRData
		test eax,eax
		     jz CannotModDrawDist_RT

	fld DWORD [ebx]
	fadd DWORD [esp+24]
	fstp DWORD [ebx]

;re-protect ".rdata" section
	mov ecx,[DATASEC_STARTADDR]
	mov edx,[RDATA_START_ADDR]
	sub ecx,edx
invoke VirtualProtectEx,edi,edx,ecx,[VOldProtectRData],VOldProtectRData

CannotModDrawDist_RT:
pop edi
pop ebx
pop edx
pop ecx
pop eax
ret 4
